#include <string>
#include <list>
#include <stdexcept>
#include <cstdio>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include "Interaction.h"
using namespace std;

void Interaction::prepare(const list<string>& l)
{
//	int fd[4];
	int fd[2];

	if(pipe(fd))
		throw runtime_error("pipe() failed.");
//	if(pipe(fd+2))
//		throw runtime_error("pipe() failed.");

	// P    C
	// 0 <- 1
	// 3 -> 2
	
	childpid=fork();
	if(childpid<0)
		throw runtime_error("fork() failed.");
	else if(childpid==0)
	{
		// dziecko
		close(fd[0]);	// czytanie
//		close(fd[3]);	// pisanie

		dup2(fd[1], STDOUT_FILENO);
		close(fd[1]);
//		dup2(fd[2], STDIN_FILENO);
//		close(fd[2]);
		close(STDIN_FILENO);

		int i=0;
		char **argv=new char*[l.size()+1];
		for(list<string>::const_iterator it=l.begin(); it!=l.end(); it++)
			argv[i++]=(char*)it->c_str();
		argv[i]='\0';
		
		execvp(l.begin()->c_str(), argv);
		
		throw runtime_error("exec() failed.");
	}
	else
	{
		// rodzic
		close(fd[1]);	// pisanie
//		close(fd[2]);	// czytanie
		output=fdopen(fd[0], "r");
//		input=fdopen(fd[3], "w");
	}
}

Interaction::Interaction(const string& cmd)
	: terminated(false)
{
	list<string> l;
	l.push_back(cmd);
	
	prepare(l);
}

Interaction::Interaction(const list<string>& cmd)
	: terminated(false)
{
	prepare(cmd);
}

Interaction::~Interaction()
{
	if(!terminated)
		terminate();
}

int Interaction::getc()
{
	return fgetc(output);
}

string Interaction::gets()
{
	char buf[4096];
	
	fgets(buf, 4096, output);
	
	return buf;
}

//void Interaction::putc(int c)
//{
//	fputc(c, input);
//}

//void Interaction::puts(string s)
//{
//	fputs(s.c_str(), input);
//}

// Mona stwierdzi, e nastpi koniec pliku dopiero po odczycie z pliku.
// feof() zwraca false nawet jeeli nastpny odczyt z pliku zwraca EOF.
bool Interaction::eof()
{
	int tmp=fgetc(output);
	
	if(tmp==EOF)
		return true;
	
	ungetc(tmp, output);
	
	return false;
}

int Interaction::terminate()
{
	int retval;

	fclose(output);
//	fclose(input);
	waitpid(childpid, &retval, 0);
	terminated=true;

	return retval;
}
