#include <stdexcept>
#include <iostream>
#include <list>
#include <string>
#include <iterator>
#include "PackageTree.h"
#include "String.h"
#include "Transaction.h"
using namespace std;

int main()
{
	PackageTree pt;
	
	try
	{
		cout << pt.fillup() << endl;
	}
	catch(runtime_error e)
	{
		cout << "Taki bd: " << e.what() << endl;
		return 1;
	}
	pt.check_installed();

	cout << pt.root_group().getname() << endl;

	Package& p=pt.find_package("zsh");
	
	cout << p.getname() << "-" << p.getversion() << "-" << p.getrelease() << endl;
	if(p.isinstalled())
		cout << "1" << endl;

	pt.recheck_installed();

	if(p.isinstalled())
		cout << "1" << endl;

	list<string> l=p.getdescription();
	copy(l.begin(), l.end(), ostream_iterator<string>(cout));

	Transaction t, t2;
	t.try_command("fribidi-devel", OP_INSTALL);
//	t.doit();
	t2.try_command("fribidi", OP_UNINSTALL);
//	t2.doit();
}
